#include "descriptor/descriptor.h"



//  Dimensioni di di alcuni degli oggetti presenti nella scena
#define DIM_STANZA_X 24.1646
#define DIM_STANZA_Y 37.8092
#define DIM_STANZA_Z 14.17845

#define DIM_TAVOLO_QUADRATO_XY 3.57
#define DIM_TAVOLO_QUADRATO_Z 3.047

#define DIM_BILIARDO_X 5.26
#define DIM_BILIARDO_Y 9.4523
#define DIM_BILIARDO_Z 3.810

#define DIM_PIEDISTALLO_XY 2.535
#define DIM_PIEDISTALLO_Z 4.5

#define DIM_SPECCHIO_PICCOLO_X 1.496
#define DIM_SPECCHIO_PICCOLO_Y 0.076
#define DIM_SPECCHIO_PICCOLO_Z 2.6

#define DIM_SPECCHIO_NASCOSTO_X 0.140
#define DIM_SPECCHIO_NASCOSTO_Y 2.582
#define DIM_SPECCHIO_NASCOSTO_Z 4.598

#define DIM_OROLOGIO_X 2.34
#define DIM_OROLOGIO_Y 0.716
#define DIM_OROLOGIO_Z 3.744

#define DIM_TAVOLO_ROSSO_XY 4.29
#define DIM_TAVOLO_ROSSO_Z 2.833

#define DIM_BANCONE_X 6.304
#define DIM_BANCONE_Y 4.558
#define DIM_BANCONE_Z 4.749

#define DIM_TAVOLO_LUNGO_X 2.564
#define DIM_TAVOLO_LUNGO_Y 9.263
#define DIM_TAVOLO_LUNGO_Z 2.737

#define DIM_SPECCHIO_ARCUATO_X 0.198
#define DIM_SPECCHIO_ARCUATO_Y 2.514
#define DIM_SPECCHIO_ARCUATO_Z 5.939



//  Enumerazione degli attributi degli oggetti
#define LEGNO_LUCIDO 0
#define MURO_ROSSO 1
#define MURO_VERDE 2
#define PLASTICA_NERA 3
#define TESSUTO 4
#define MURO_ROSSO2 5
#define MURO_VERDE2 6
#define MURO_BIANCO 7
#define RESINA_FENOLICA_BIANCA 8
#define RESINA_FENOLICA_ROSSA 9
#define RESINA_FENOLICA_GIALLA 10
#define LEGNO_OPACO 11
#define FERRO 12
#define LEGNO_RIVESTITO_BLU 13
#define LEGNO_RIVESTITO_MARRONCINO 14
#define RIFLETTENTE_ACQUAMARINA 15
#define SPECCHIO 16
#define PLASTICA_BIANCA 17
#define VETRO_TRASPARENTE 18
#define PLASTICA_ROSSA 19
#define LEGNO_RIVESTITO_VERDE 20
#define VETRO_BIANCO 21
#define VETRO_GIALLO 22



//  Profondita' di annidamento della scena dentro la teca
#define TECA_DEEP 3



//  Vettore degli attributi degli oggetti
ITEM attributes[23];



//  Funzione che riempie il vettore con gli attributi degli oggetti
void set_attributes(ITEM att[]) {

	att[LEGNO_LUCIDO] = create_attribute("Legno-Lucido");
	set_color(att[LEGNO_LUCIDO], 0.5,0.5,0.5, 0.5,0.5);
	set_reflectivity(att[LEGNO_LUCIDO], 0.055,2);

	att[MURO_ROSSO] = create_attribute("Muro-Rosso");
	set_color(att[MURO_ROSSO], 0.561,0.133,0.145, 0.6,0.6);

	att[MURO_VERDE] = create_attribute("Muro-Verde");
	set_color(att[MURO_VERDE], 0.224,0.376,0.302, 0.6,0.6);

	att[PLASTICA_NERA] = create_attribute("Plastica-Nera");
	set_color(att[PLASTICA_NERA], 0,0,0, 0.5,0.5);
	set_reflectivity(att[PLASTICA_NERA], 0.125,2);

	att[TESSUTO] = create_attribute("Tessuto");
	set_color(att[TESSUTO], 0.5,0.5,0.5, 0.5,0.5);

	att[MURO_ROSSO2] = create_attribute("Muro-Rosso2");
	set_color(att[MURO_ROSSO2], 1,0,0, 0.5,0.5);

	att[MURO_VERDE2] = create_attribute("Muro-Verde2");
	set_color(att[MURO_VERDE2], 0,1,0, 0.5,0.5);

	att[MURO_BIANCO] = create_attribute("Muro-Bianco");
	set_color(att[MURO_BIANCO], 1,1,1, 0.5,0.5);

	att[RESINA_FENOLICA_BIANCA] = create_attribute("Resina-Fenolica-Bianca");
	set_color(att[RESINA_FENOLICA_BIANCA], 1,1,1, 0.55,0.55);
	set_reflectivity(att[RESINA_FENOLICA_BIANCA], 0.185,5);

	att[RESINA_FENOLICA_ROSSA] = create_attribute("Resina-Fenolica-Rossa");
	set_color(att[RESINA_FENOLICA_ROSSA], 1,0,0, 0.55,0.55);
	set_reflectivity(att[RESINA_FENOLICA_ROSSA], 0.185,5);

	att[RESINA_FENOLICA_GIALLA] = create_attribute("Resina-Fenolica-Gialla");
	set_color(att[RESINA_FENOLICA_GIALLA], 1,1,0, 0.55,0.55);
	set_reflectivity(att[RESINA_FENOLICA_GIALLA], 0.185,5);

	att[LEGNO_OPACO] = create_attribute("Legno-Opaco");
	set_color(att[LEGNO_OPACO], 0.5,0.5,0.5, 0.5,0.5);

	att[FERRO] = create_attribute("Ferro");
	set_color(att[FERRO], 0.106,0.094,0.161, 0.3,0.3);

	att[LEGNO_RIVESTITO_BLU] = create_attribute("Legno-Rivestito-Blu");
	set_color(att[LEGNO_RIVESTITO_BLU], 0.133,0.141,0.192, 0.6,0.6);

	att[LEGNO_RIVESTITO_MARRONCINO] = create_attribute("Legno-Rivestito-Marroncino");
	set_color(att[LEGNO_RIVESTITO_MARRONCINO], 0.741,0.553,0.361, 0.6,0.6);

	att[RIFLETTENTE_ACQUAMARINA] = create_attribute("Riflettente-Acquamarina");
	set_color(att[RIFLETTENTE_ACQUAMARINA], 0.761,0.8,0.765, 0.4,0.4);
	set_reflectivity(att[RIFLETTENTE_ACQUAMARINA], 0.45,2);

	att[SPECCHIO] = create_attribute("Specchio");
	set_color(att[SPECCHIO], 0.5,0.5,0.5, 0,0);
	set_reflectivity(att[SPECCHIO], 1,500);

	att[PLASTICA_BIANCA] = create_attribute("Plastica-Bianca");
	set_color(att[PLASTICA_BIANCA], 1,1,1, 0.5,0.5);
	set_reflectivity(att[PLASTICA_BIANCA], 0.125,2);

	att[VETRO_TRASPARENTE] = create_attribute("Vetro-Trasparente");
	set_color(att[VETRO_TRASPARENTE], 1,1,1, 0.5,0.5);
	set_reflectivity(att[VETRO_TRASPARENTE], 0.240,250);
	set_transparency(att[VETRO_TRASPARENTE], 1,0,5,1.502);

	att[PLASTICA_ROSSA] = create_attribute("Plastica-Rossa");
	set_color(att[PLASTICA_ROSSA], 0.608,0.196,0.184, 0.8,0.8);
	set_reflectivity(att[PLASTICA_ROSSA], 0.125,2);

	att[LEGNO_RIVESTITO_VERDE] = create_attribute("Legno-Rivestito-Verde");
	set_color(att[LEGNO_RIVESTITO_VERDE], 0.592,0.655,0.4, 0.7,0.7);

	att[VETRO_BIANCO] = create_attribute("Vetro-Bianco-Satinato");
	set_color(att[VETRO_BIANCO], 1,1,1, 1,1);
	set_reflectivity(att[VETRO_BIANCO], 0.024,4);
	set_transparency(att[VETRO_BIANCO], 0.1,0,5,1.502);

	att[VETRO_GIALLO] = create_attribute("Vetro-Giallo-Satinato");
	set_color(att[VETRO_GIALLO], 0.976,0.965,0.110, 0.3,0.3);
	set_reflectivity(att[VETRO_GIALLO], 0.24,4);
	set_transparency(att[VETRO_GIALLO], 0.2,0.1,5,1.502);
}


//  Stanza & tenda
ITEM load_and_set_stanza() {

	//Carico le superfici che compongono la stanza
	ITEM pavimento = read_nurbs("stanza-pavimento.db");
	ITEM muro1 = read_nurbs("stanza-muro1.dbe");
	ITEM muro2 = read_nurbs("stanza-muro2.dbe");
	ITEM soffitto = read_nurbs("stanza-soffitto.db");
	ITEM bastone = read_nurbs("stanza-bastone.db");
	ITEM tenda = read_nurbs("stanza-tenda.db");

	//Setto gli attributi delle superfici della stanza
	set_domain_texture(pavimento,attributes[LEGNO_LUCIDO],"textures/legno-pavimento.hr", 0,0.3,0,0.3, TRUE, 0.6,0.6);
	set_domain_texture(muro1,attributes[LEGNO_LUCIDO],"textures/legno-muro.hr", 0,0.035,0,0.5, TRUE, 0.3,0.3);
	set_bump_texture(muro2,attributes[MURO_ROSSO],"textures/bump-muro.hr", 0,0.005,0,0.005, TRUE, 0.025,-1);
	set_bump_texture(soffitto,attributes[MURO_VERDE],"textures/bump-muro.hr", 0,0.025,0,0.025, TRUE, 0.01,-1);
	set_attribute(bastone,attributes[PLASTICA_NERA]);
	set_domain_texture(tenda,attributes[TESSUTO],"textures/stoffa-tenda.hr", 0,0.1,0,0.1, TRUE, 0.175,0.175);

	//Creo la lista delle superfici
	ITEM stanza = create_list(pavimento,"Stanza");
	stanza = insert_in_list(stanza,muro1);
	stanza = insert_in_list(stanza,muro2);
	stanza = insert_in_list(stanza,soffitto);
	stanza = insert_in_list(stanza,bastone);
	stanza = insert_in_list(stanza,tenda);

	return stanza;
}



//  Cornell box (nella stanzetta al di la' della tenda)
ITEM load_and_set_cornell_box() {

	//Carico le superfici che compongono la stanzetta
	ITEM muro_sx = read_nurbs("cornell-box-sx.db");
	ITEM muro_dx = read_nurbs("cornell-box-dx.db");
	ITEM muro_ctr = read_nurbs("cornell-box-ctr.dbe");
	ITEM lampadario = read_nurbs("cornell-box-luce.db");
	ITEM palla1 = read_nurbs("cornell-box-palla1.db");
	ITEM palla2 = read_nurbs("cornell-box-palla2.db");

	//Setto gli attributi delle superfici della stanza
	set_attribute(muro_sx,attributes[MURO_ROSSO2]);
	set_attribute(muro_dx,attributes[MURO_VERDE2]);
	set_attribute(muro_ctr,attributes[MURO_BIANCO]);
	set_attribute(lampadario,attributes[VETRO_BIANCO]);
	set_attribute(palla2,attributes[SPECCHIO]);
	set_attribute(palla1,attributes[VETRO_TRASPARENTE]);
	
	//Creo la lista delle superfici
	ITEM box = create_list(muro_sx,"Cornell-Box");
	box = insert_in_list(box,muro_dx);
	box = insert_in_list(box,muro_ctr);
	box = insert_in_list(box,lampadario);
	box = insert_in_list(box,palla1);
	box = insert_in_list(box,palla2);

	return box;
}
	


//  Biliardo, stecca & palline
ITEM load_and_set_biliardo() {

	//Carico le superfici che compongo il biliardo (il biliardo stesso, le 3 palle e la stecca)
	ITEM tubolare_esterno = read_nurbs("biliardo-tubolare-esterno.db");
	ITEM tubolare_interno = read_nurbs("biliardo-tubolare-interno.db");
	ITEM panno = read_nurbs("biliardo-panno.db");
	ITEM cassa = read_nurbs("biliardo-cassa.db");
	ITEM gamba1 = read_nurbs("biliardo-gamba1.db");
	ITEM gamba2 = read_nurbs("biliardo-gamba2.db");
	ITEM gamba3 = read_nurbs("biliardo-gamba3.db");
	ITEM gamba4 = read_nurbs("biliardo-gamba4.db");
	ITEM stecca = read_nurbs("biliardo-stecca.db");
	ITEM palla1 = read_nurbs("biliardo-palla1.db");
	ITEM palla2 = read_nurbs("biliardo-palla2.db");
	ITEM palla3 = read_nurbs("biliardo-palla3.db");

	//Setto gli attributi delle superfici del biliardo
	set_domain_texture(tubolare_esterno,attributes[LEGNO_LUCIDO],"textures/legno-biliardo.hr", 0,0.6,0,0.05, TRUE, 0.45,0.45);
	set_domain_texture(tubolare_interno,attributes[TESSUTO],"textures/panno.hr", 0,0.15,0,0.1, TRUE, 0.3,0.3);
	set_domain_texture(panno,attributes[TESSUTO],"textures/panno.hr", 0,0.1,0,0.1, TRUE, 0.3,0.3);
	set_domain_texture(cassa,attributes[LEGNO_LUCIDO],"textures/legno-biliardo.hr", 0,0.1,0,0.3, TRUE, 0.45,0.45);
	set_domain_texture(gamba1,attributes[LEGNO_LUCIDO],"textures/legno-biliardo.hr", 0,0.5,0,0.3, TRUE, 0.45,0.45);
	set_domain_texture(gamba2,attributes[LEGNO_LUCIDO],"textures/legno-biliardo.hr", 0,0.5,0,0.3, TRUE, 0.45,0.45);
	set_domain_texture(gamba3,attributes[LEGNO_LUCIDO],"textures/legno-biliardo.hr", 0,0.5,0,0.3, TRUE, 0.45,0.45);
	set_domain_texture(gamba4,attributes[LEGNO_LUCIDO],"textures/legno-biliardo.hr", 0,0.5,0,0.3, TRUE, 0.45,0.45);
	set_translate(stecca,-0.51257,2.34802,-3.61551);
	set_z_rotate(stecca,8.626640085,1);
	set_x_rotate(stecca,-0.77470393,1);
	set_scale(stecca,0.334009703,0.334009703,0.334009703);
	set_translate(stecca,0.5,-1,0.5);
	set_projection_texture(stecca,attributes[LEGNO_LUCIDO],"textures/stecca.hr", 0,TRUE, 0.4,0.4);
	set_translate(stecca,-0.5,1,-0.5);
	set_scale(stecca,2.993925,2.993925,2.993925);
	set_x_rotate(stecca,0.77470393,1);
	set_z_rotate(stecca,-8.626640085,1);
	set_translate(stecca,0.51257,-2.34802,3.61551);
	set_attribute(palla1,attributes[RESINA_FENOLICA_BIANCA]);
	set_attribute(palla2,attributes[RESINA_FENOLICA_ROSSA]);
	set_attribute(palla3,attributes[RESINA_FENOLICA_GIALLA]);

	//Creo la lista delle superfici componenti il biliardo
	ITEM biliardo = create_list(tubolare_esterno,"Biliardo");
	biliardo = insert_in_list(biliardo,tubolare_interno);
	biliardo = insert_in_list(biliardo,panno);
	biliardo = insert_in_list(biliardo,cassa);
	biliardo = insert_in_list(biliardo,gamba1);
	biliardo = insert_in_list(biliardo,gamba2);
	biliardo = insert_in_list(biliardo,gamba3);
	biliardo = insert_in_list(biliardo,gamba4);
	biliardo = insert_in_list(biliardo,stecca);
	biliardo = insert_in_list(biliardo,palla1);
	biliardo = insert_in_list(biliardo,palla2);
	biliardo = insert_in_list(biliardo,palla3);

	set_translate(biliardo,-0.8,-3,0);

	return biliardo;
}



//  Tavolino quadrato azzurro in fondo di fianco alla tenda
ITEM load_and_set_tavolo_quadrato1() {
	
	//Carico le superfici che compongono il tavolino quadrato (la gamba del tavolo e la superficie d'appoggio)
	ITEM gamba = read_nurbs("quadrato-gamba.db");
	ITEM superficie = read_nurbs("quadrato-superficie.db");

	//Setto gli attributi delle superfici
	set_scale(superficie, 0.560224089,0.560224089,0.560224089);
	set_projection_texture(superficie,attributes[LEGNO_OPACO],"textures/legno-azzurro.hr", 2,TRUE, 0.55,0.55);
	set_scale(superficie, 1.785,1.785,1.785);
	set_domain_texture(gamba,attributes[FERRO],"textures/ferro.hr", 0,0.1,0,0.1, TRUE, 0.4,0.4);

	//Creo la lista delle superfici
	ITEM tavolo_quadrato1 = create_list(gamba,"Tavolo-Quadrato1");
	tavolo_quadrato1 = insert_in_list(tavolo_quadrato1,superficie);

	//Posiziono il tavolo nello spazio
	set_translate(tavolo_quadrato1,-DIM_STANZA_X/8*3,DIM_STANZA_Y/2-DIM_TAVOLO_QUADRATO_XY/2,0);

	return tavolo_quadrato1;
}



//  Tavolino quadrato azzurro di fianco allo specchio seminascosto
ITEM load_and_set_tavolo_quadrato2() {
	
	//Carico le superfici che compongono il tavolino quadrato (la gamba del tavolo e la superficie d'appoggio)
	ITEM gamba = read_nurbs("quadrato-gamba.db");
	ITEM superficie = read_nurbs("quadrato-superficie.db");

	//Setto gli attributi delle superfici
	set_scale(superficie, 0.560224089,0.560224089,0.560224089);
	set_projection_texture(superficie,attributes[LEGNO_OPACO],"textures/legno-azzurro.hr", 2,TRUE, 0.55,0.55);
	set_scale(superficie, 1.785,1.785,1.785);
	set_domain_texture(gamba,attributes[FERRO],"textures/ferro.hr", 0,0.1,0,0.1, TRUE, 0.4,0.4);
	
	//Creo la lista delle superfici
	ITEM tavolo_quadrato2 = create_list(gamba,"Tavolo-Quadrato2");
	tavolo_quadrato2 = insert_in_list(tavolo_quadrato2,superficie);

	//Posiziono il tavolo nello spazio
	set_translate(tavolo_quadrato2,-DIM_STANZA_X/2+DIM_TAVOLO_QUADRATO_XY/2,9.5,0);

	return tavolo_quadrato2;
}



//  Tavolino quadrato azzurro prima del piedistallo rispetto all'osservatore
ITEM load_and_set_tavolo_quadrato3() {
	
	//Carico le superfici che compongono il tavolino quadrato (la gamba del tavolo e la superficie d'appoggio)
	ITEM gamba = read_nurbs("quadrato-gamba.db");
	ITEM superficie = read_nurbs("quadrato-superficie.db");

	//Setto gli attributi delle superfici
	set_scale(superficie, 0.560224089,0.560224089,0.560224089);
	set_projection_texture(superficie,attributes[LEGNO_OPACO],"textures/legno-azzurro.hr", 2,TRUE, 0.55,0.55);
	set_scale(superficie, 1.785,1.785,1.785);
	set_domain_texture(gamba,attributes[FERRO],"textures/ferro.hr", 0,0.1,0,0.1, TRUE, 0.4,0.4);

	//Creo la lista delle superfici
	ITEM tavolo_quadrato3 = create_list(gamba,"Tavolo-Quadrato3");
	tavolo_quadrato3 = insert_in_list(tavolo_quadrato3,superficie);

	//Posiziono il tavolo nello spazio
	set_z_rotate(tavolo_quadrato3,-10,1);
	set_translate(tavolo_quadrato3,-9.5,0,0);

	return tavolo_quadrato3;
}



//  Tavolino quadrato azzurro piu' vicino all'osservatore
ITEM load_and_set_tavolo_quadrato4() {
	
	//Carico le superfici che compongono il tavolino quadrato (la gamba del tavolo e la superficie d'appoggio)
	ITEM gamba = read_nurbs("quadrato-gamba.db");
	ITEM superficie = read_nurbs("quadrato-superficie.db");

	//Setto gli attributi delle superfici
	set_scale(superficie, 0.560224089,0.560224089,0.560224089);
	set_projection_texture(superficie,attributes[LEGNO_OPACO],"textures/legno-azzurro.hr", 2,TRUE, 0.55,0.55);
	set_scale(superficie, 1.785,1.785,1.785);
	set_domain_texture(gamba,attributes[FERRO],"textures/ferro.hr", 0,0.1,0,0.1, TRUE, 0.4,0.4);

	//Creo la lista delle superfici
	ITEM tavolo_quadrato4 = create_list(gamba,"Tavolo-Quadrato4");
	tavolo_quadrato4 = insert_in_list(tavolo_quadrato4,superficie);

	//Posiziono il tavolo nello spazio
	set_z_rotate(tavolo_quadrato4,5,1);
	set_translate(tavolo_quadrato4,-9.75,-6.85,0);

	return tavolo_quadrato4;
}



//  Piedistallo
ITEM load_and_set_piedistallo() {
	
	//Carico le superfici che compongono il piedistallo
	ITEM base1 = read_nurbs("piedistallo-base1.db");
	ITEM base2 = read_nurbs("piedistallo-base2.db");
	ITEM base3 = read_nurbs("piedistallo-base3.db");
	ITEM colonna = read_nurbs("piedistallo-colonna.db");
	ITEM superficie1 = read_nurbs("piedistallo-superficie1.db");
	ITEM superficie2 = read_nurbs("piedistallo-superficie2.db");

	//Setto gli attributi delle superfici	
	set_attribute(base1,attributes[LEGNO_RIVESTITO_BLU]);
	set_attribute(base2,attributes[LEGNO_RIVESTITO_BLU]);
	set_attribute(base3,attributes[LEGNO_RIVESTITO_BLU]);
	set_attribute(colonna,attributes[LEGNO_RIVESTITO_BLU]);
	set_attribute(superficie1,attributes[LEGNO_RIVESTITO_MARRONCINO]);
	set_attribute(superficie2,attributes[RIFLETTENTE_ACQUAMARINA]);

	//Creo la lista delle superfici
	ITEM piedistallo = create_list(base1,"Piedistallo");
	piedistallo = insert_in_list(piedistallo,base2);
	piedistallo = insert_in_list(piedistallo,base3);
	piedistallo = insert_in_list(piedistallo,colonna);
	piedistallo = insert_in_list(piedistallo,superficie1);
	piedistallo = insert_in_list(piedistallo,superficie2);

	//Posiziono il piedistallo nello spazio
	set_translate(piedistallo,-8.5,4,0);

	return piedistallo;
}



//  Specchio in fondo di fianco alla tenda
ITEM load_and_set_specchio_piccolo() {
	
	//Carico le superfici che compongono lo specchio (la cornice e la superficie riflettente)
	ITEM cornice = read_nurbs("piccolo-cornice.db");
	ITEM specchio = read_nurbs("piccolo-specchio.db");

	//Setto gli attributi delle superfici
	set_attribute(cornice,attributes[PLASTICA_NERA]);
	set_attribute(specchio,attributes[SPECCHIO]);

	//Creo la lista delle superfici
	ITEM piccolo = create_list(cornice,"Specchio-Piccolo");
	piccolo = insert_in_list(piccolo,specchio);

	//Posiziono lo specchio nella scena
	set_translate(piccolo,-DIM_STANZA_X/8*3-DIM_TAVOLO_QUADRATO_XY/2+DIM_SPECCHIO_PICCOLO_X/2,DIM_STANZA_Y/2,DIM_STANZA_Z/3+1);

	return piccolo;
}



//  Specchio seminascosto sulla parete sinistra
ITEM load_and_set_specchio_nascosto() {
	
	//Carico le superfici che compongono lo specchio (la cornice e la superfice riflettente)
	ITEM cornice = read_nurbs("nascosto-cornice.db");
	ITEM specchio = read_nurbs("nascosto-specchio.db");

	//Setto gli attributi delle superfici
	set_domain_texture(cornice,attributes[LEGNO_LUCIDO],"textures/legno-specchio.hr", 0,0.5,0,0.5, TRUE, 0.25,0.25);
	set_attribute(specchio,attributes[SPECCHIO]);

	//Creo la lista delle superfici
	ITEM nascosto = create_list(cornice,"Specchio-Nascosto");
	nascosto = insert_in_list(nascosto,specchio);

	//Posiziono lo specchio nella scena
	set_translate(nascosto,-DIM_STANZA_X/2,9.5+DIM_TAVOLO_QUADRATO_XY/2-DIM_SPECCHIO_NASCOSTO_Y/2,DIM_STANZA_Z/3+1);

	return nascosto;
}



//  Orologio appeso al muro
ITEM load_and_set_orologio() {
	
	//Carico le superfici che compongono l'orologio
	ITEM base1 = read_nurbs("orologio-base1.db");
	ITEM base2 = read_nurbs("orologio-base2.db");
	ITEM base3 = read_nurbs("orologio-base3.db");
	ITEM quadrante = read_nurbs("orologio-quadrante.db");
	ITEM vetro = read_nurbs("orologio-vetro.db");
	ITEM lancetta_ore = read_nurbs("orologio-lancetta-ore.db");
	ITEM lancetta_minuti = read_nurbs("orologio-lancetta-minuti.db");

	//Setto gli attributi delle superfici
	set_domain_texture(base1,attributes[LEGNO_LUCIDO],"textures/legno-orologio.hr", 0,0.25,0,0.25, TRUE, 0.75,0.75);
	set_domain_texture(base2,attributes[LEGNO_LUCIDO],"textures/legno-orologio.hr", 0,0.25,0,0.25, TRUE, 0.75,0.75);
	set_domain_texture(base3,attributes[LEGNO_LUCIDO],"textures/legno-orologio.hr", 0,0.25,0,0.25, TRUE, 0.75,0.75);
	set_scale(quadrante,1.26984127,1.26984127,1.058201058);
	set_projection_texture(quadrante,attributes[PLASTICA_BIANCA],"textures/quadrante.hr", 1,TRUE, 0.5,0.5);
	set_scale(quadrante,0.7875,0.7875,0.945);
	set_attribute(lancetta_ore,attributes[PLASTICA_NERA]);
	set_attribute(lancetta_minuti,attributes[PLASTICA_NERA]);
	set_attribute(vetro,attributes[VETRO_TRASPARENTE]);


	//Creo la lista delle superfici
	ITEM orologio = create_list(base1,"Orologio");
	orologio = insert_in_list(orologio,base2);
	orologio = insert_in_list(orologio,base3);
	orologio = insert_in_list(orologio,quadrante);
	orologio = insert_in_list(orologio,vetro);
	orologio = insert_in_list(orologio,lancetta_ore);
	orologio = insert_in_list(orologio,lancetta_minuti);

	//Posiziono l'orologio nella scena
	set_translate(orologio,-1,DIM_STANZA_Y/2,12);

	return orologio;
}



//  Tavolino quadrato rosso in fondo a destra nell'angolo
ITEM load_and_set_tavolo_rosso() {
	
	//Carico le superfici che compongono il tavolo
	ITEM superficie1 = read_nurbs("rosso-superficie1.db");
	ITEM superficie2 = read_nurbs("rosso-superficie2.db");
	ITEM gamba1 = read_nurbs("rosso-gamba1.db");
	ITEM gamba2 = read_nurbs("rosso-gamba2.db");
	ITEM gamba3 = read_nurbs("rosso-gamba3.db");
	ITEM gamba4 = read_nurbs("rosso-gamba4.db");

	//Setto gli attributi delle superfici
	set_domain_texture(gamba1,attributes[LEGNO_OPACO],"textures/legno-tavolo-rosso.hr", 0,0.35,0,0.5, TRUE, 0.35,0.35);
	set_domain_texture(gamba2,attributes[LEGNO_OPACO],"textures/legno-tavolo-rosso.hr", 0,0.35,0,0.5, TRUE, 0.35,0.35);
	set_domain_texture(gamba3,attributes[LEGNO_OPACO],"textures/legno-tavolo-rosso.hr", 0,0.35,0,0.5, TRUE, 0.35,0.35);
	set_domain_texture(gamba4,attributes[LEGNO_OPACO],"textures/legno-tavolo-rosso.hr", 0,0.35,0,0.5, TRUE, 0.35,0.35);
	set_domain_texture(superficie1,attributes[LEGNO_OPACO],"textures/legno-tavolo-rosso.hr", 0,0.10,0,0.25, TRUE, 0.35,0.35);
	set_attribute(superficie2,attributes[PLASTICA_ROSSA]);

	//Creo la lista delle superfici
	ITEM rosso = create_list(superficie1,"Tavolo-Rosso");
	rosso = insert_in_list(rosso,superficie2);
	rosso = insert_in_list(rosso,gamba1);
	rosso = insert_in_list(rosso,gamba2);
	rosso = insert_in_list(rosso,gamba3);
	rosso = insert_in_list(rosso,gamba4);

	//Posiziono il tavolo nella scena
	set_translate(rosso,DIM_STANZA_X/2-DIM_TAVOLO_ROSSO_XY/2-3,DIM_STANZA_Y/2-DIM_TAVOLO_ROSSO_XY/2-2.7,0);

	return rosso;
}



//  Bancone verde in fondo
ITEM load_and_set_bancone() {

	//Carico le superfici che compongono il bancone
	ITEM base = read_nurbs("bancone-base.db");
	ITEM sostegno = read_nurbs("bancone-sostegno.db");
	ITEM zoccolo = read_nurbs("bancone-zoccolo.db");
	ITEM piano = read_nurbs("bancone-piano.db");

	//Setto gli attributi delle superfici
	set_attribute(base,attributes[PLASTICA_NERA]);
	set_attribute(sostegno,attributes[LEGNO_RIVESTITO_VERDE]);
	set_attribute(zoccolo,attributes[LEGNO_RIVESTITO_VERDE]);
	set_attribute(piano,attributes[LEGNO_RIVESTITO_VERDE]);

	//Creo la lista delle superfici
	ITEM bancone = create_list(base,"Bancone");
	bancone = insert_in_list(bancone,sostegno);
	bancone = insert_in_list(bancone,zoccolo);
	bancone = insert_in_list(bancone,piano);

	//Posiziono il bancone nella scena
	set_translate(bancone,-2.35+DIM_BANCONE_X/2,DIM_STANZA_Y/2-DIM_BANCONE_Y/2-3.2,0);

	return bancone;
}



//  Tavolo azzurro lungo piu' lontano rispetto all'osservatore
ITEM load_and_set_tavolo_lungo1() {

	//Carico le superfici che compongono il tavolo
	ITEM superficie = read_nurbs("lungo-superficie.db");
	ITEM gamba1 = read_nurbs("lungo-gamba1.db");
	ITEM gamba2 = read_nurbs("lungo-gamba2.db");

	//Setto gli attributi delle superfici
	set_scale(superficie, 0.216543958,0.730727073,1);
	set_projection_texture(superficie,attributes[LEGNO_OPACO],"textures/legno-azzurro.hr", 2,TRUE, 0.55,0.55);
	set_scale(superficie, 4.618000009,1.3685,1);
	set_domain_texture(gamba1,attributes[LEGNO_OPACO],"textures/legno-gambe-tavoli.hr", 0,0.4,0,0.4, TRUE, 0.2,0.2);
	set_domain_texture(gamba2,attributes[LEGNO_OPACO],"textures/legno-gambe-tavoli.hr", 0,0.4,0,0.4, TRUE, 0.2,0.2);
		
	//Creo la lista delle superfici
	ITEM lungo = create_list(superficie,"Tavolo-Lungo1");
	lungo = insert_in_list(lungo,gamba1);
	lungo = insert_in_list(lungo,gamba2);

	//Posiziono il tavolo nella scena
	set_translate(lungo,DIM_STANZA_X/2-DIM_TAVOLO_LUNGO_X/2-3.5,4,0);

	return lungo;
}



//  Tavolo azzurro lungo piu' vicino rispetto all'osservatore
ITEM load_and_set_tavolo_lungo2() {

	//Carico le superfici che compongono il tavolo
	ITEM superficie = read_nurbs("lungo-superficie.db");
	ITEM gamba1 = read_nurbs("lungo-gamba1.db");
	ITEM gamba2 = read_nurbs("lungo-gamba2.db");

	//Setto gli attributi delle superfici
	set_scale(superficie, 0.216543958,0.730727073,1);
	set_projection_texture(superficie,attributes[LEGNO_OPACO],"textures/legno-azzurro.hr", 2,TRUE, 0.55,0.55);
	set_scale(superficie, 4.618000009,1.3685,1);
	set_domain_texture(gamba1,attributes[LEGNO_OPACO],"textures/legno-gambe-tavoli.hr", 0,0.4,0,0.4, TRUE, 0.2,0.2);
	set_domain_texture(gamba2,attributes[LEGNO_OPACO],"textures/legno-gambe-tavoli.hr", 0,0.4,0,0.4, TRUE, 0.2,0.2);

	//Creo la lista delle superfici
	ITEM lungo = create_list(superficie,"Tavolo-Lungo2");
	lungo = insert_in_list(lungo,gamba1);
	lungo = insert_in_list(lungo,gamba2);

	//Posiziono il tavolo nella scena
	set_translate(lungo,DIM_STANZA_X/2-DIM_TAVOLO_LUNGO_X/2-4,-8.5,0);

	return lungo;
}



//  Specchio sulla parete destra
ITEM load_and_set_specchio_arcuato() {
	
	//Carico le superfici che compongono lo specchio
	ITEM cornice_alta = read_nurbs("arcuato-cornice-alta.db");
	ITEM cornice_bassa = read_nurbs("arcuato-cornice-bassa.db");
	ITEM specchio_alto = read_nurbs("arcuato-specchio-alto.db");
	ITEM specchio_basso = read_nurbs("arcuato-specchio-basso.db");

	//Setto gli attributi delle superfici
	set_domain_texture(cornice_alta,attributes[LEGNO_LUCIDO],"textures/legno-specchio.hr", 0,0.5,0,0.5, TRUE, 0.4,0.4);
	set_domain_texture(cornice_bassa,attributes[LEGNO_LUCIDO],"textures/legno-specchio.hr", 0,0.5,0,0.5, TRUE, 0.4,0.4);
	set_attribute(specchio_alto,attributes[SPECCHIO]);
	set_attribute(specchio_basso,attributes[SPECCHIO]);

	//Creo la lista delle superfici
	ITEM arcuato = create_list(cornice_alta,"Specchio-arcuato");
	arcuato = insert_in_list(arcuato,cornice_bassa);
	arcuato = insert_in_list(arcuato,specchio_alto);
	arcuato = insert_in_list(arcuato,specchio_basso);

	//Posiziono lo specchio nella scena
	set_translate(arcuato,DIM_STANZA_X/2,6.5,DIM_STANZA_Z/3+1);

	return arcuato;
}



//  Lampada nera
ITEM load_and_set_lampada_nera() {

	//Carico le superfici che compongono la lampada
	ITEM porta_lampada = read_nurbs("nera-porta-lampada.db");
	ITEM lampada = read_nurbs("nera-lampada.db");
	ITEM filo = read_nurbs("nera-filo.db");

	//Setto gli attributi delle superfici
	set_attribute(lampada,attributes[VETRO_BIANCO]);
	set_attribute(porta_lampada,attributes[PLASTICA_NERA]);
	set_attribute(filo,attributes[PLASTICA_NERA]);

	//Creo la lista delle superfici
	ITEM nera = create_list(porta_lampada,"Lampada-Nera");
	nera = insert_in_list(nera,lampada);
	nera = insert_in_list(nera,filo);

	//Posiziono la lampada nella scena
	set_translate(nera,-1.5,-6,DIM_STANZA_Z);

	return nera;
}


//  Lampadario giallo in fondo a sinistra
ITEM load_and_set_lampada_gialla1() {

	//Carico le superfici che compongono la lampada
	ITEM porta_lampada = read_nurbs("gialla-porta-lampada.db");
	ITEM lampadina = read_nurbs("gialla-lampadina.db");
	ITEM paralume = read_nurbs("gialla-paralume.db");
	ITEM filo = read_nurbs("gialla-filo.db");

	//Setto gli attributi delle superfici
	set_attribute(porta_lampada,attributes[PLASTICA_NERA]);
	set_attribute(lampadina,attributes[VETRO_BIANCO]);
	set_attribute(paralume,attributes[VETRO_GIALLO]);
	set_attribute(filo,attributes[PLASTICA_NERA]);

	//Creo la lista delle superfici
	ITEM gialla = create_list(porta_lampada,"Lampada-Gialla1");
	gialla = insert_in_list(gialla,lampadina);
	gialla = insert_in_list(gialla,paralume);
	gialla = insert_in_list(gialla,filo);

	//Posiziono la lampada nella scena
	set_translate(gialla,-8.6,11.5,DIM_STANZA_Z);

	return gialla;
}



//  Lampadario giallo in fondo a destra
ITEM load_and_set_lampada_gialla2() {

	//Carico le superfici che compongono la lampada
	ITEM porta_lampada = read_nurbs("gialla-porta-lampada.db");
	ITEM lampadina = read_nurbs("gialla-lampadina.db");
	ITEM paralume = read_nurbs("gialla-paralume.db");
	ITEM filo = read_nurbs("gialla-filo.db");

	//Setto gli attributi delle superfici
	set_attribute(porta_lampada,attributes[PLASTICA_NERA]);
	set_attribute(lampadina,attributes[VETRO_BIANCO]);
	set_attribute(paralume,attributes[VETRO_GIALLO]);
	set_attribute(filo,attributes[PLASTICA_NERA]);
	
	//Creo la lista delle superfici
	ITEM gialla = create_list(porta_lampada,"Lampada-Gialla2");
	gialla = insert_in_list(gialla,lampadina);
	gialla = insert_in_list(gialla,paralume);
	gialla = insert_in_list(gialla,filo);

	//Posiziono la lampada nella scena
	set_translate(gialla,3.6,5,DIM_STANZA_Z);

	return gialla;
}



//  Lampadario giallo piu' vicino all'osservatore
ITEM load_and_set_lampada_gialla3() {

	//Carico le superfici che compongono la lampada
	ITEM porta_lampada = read_nurbs("gialla-porta-lampada.db");
	ITEM lampadina = read_nurbs("gialla-lampadina.db");
	ITEM paralume = read_nurbs("gialla-paralume.db");
	ITEM filo = read_nurbs("gialla-filo.db");

	//Setto gli attributi delle superfici
	set_attribute(porta_lampada,attributes[PLASTICA_NERA]);
	set_attribute(lampadina,attributes[VETRO_BIANCO]);
	set_attribute(paralume,attributes[VETRO_GIALLO]);
	set_attribute(filo,attributes[PLASTICA_NERA]);

	//Creo la lista delle superfici
	ITEM gialla = create_list(porta_lampada,"Lampada-Gialla3");
	gialla = insert_in_list(gialla,lampadina);
	gialla = insert_in_list(gialla,paralume);
	gialla = insert_in_list(gialla,filo);

	//Posiziono la lampada nella scena
	set_translate(gialla,4.8,-6,DIM_STANZA_Z);

	return gialla;
}



//  Sedia a destra del tavolo quadrato 1
ITEM load_and_set_sedia1() {

	//Carico le superficie che compongono la sedia
	ITEM gamba1 = read_nurbs("sedia-gamba-davanti1.db");
	ITEM gamba2 = read_nurbs("sedia-gamba-davanti2.db");
	ITEM gamba3 = read_nurbs("sedia-gamba-dietro1.db");
	ITEM gamba4 = read_nurbs("sedia-gamba-dietro2.db");
	ITEM traversino1 = read_nurbs("sedia-traversino1.db");
	ITEM traversino2 = read_nurbs("sedia-traversino2.db");
	ITEM traversino3 = read_nurbs("sedia-traversino3.db");
	ITEM cuscino = read_nurbs("sedia-cuscino.db");
	ITEM poggiaschiena = read_nurbs("sedia-poggiaschiena.db");
	ITEM tappo1 = read_nurbs("sedia-tappo1.db");
	ITEM tappo2 = read_nurbs("sedia-tappo2.db");

	//Setto gli atributi delle superfici
	set_domain_texture(gamba1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.33,0,0.49, TRUE, 0.35,0.35);
	set_domain_texture(gamba2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.30,0,0.23, TRUE, 0.35,0.35);
	set_domain_texture(gamba3,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.23,0,0.31, TRUE, 0.35,0.35);
	set_domain_texture(gamba4,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.37,0,0.48, TRUE, 0.35,0.35);
	set_domain_texture(traversino1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.20,0,0.42, TRUE, 0.35,0.35);
	set_domain_texture(traversino2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.27,0,0.22, TRUE, 0.35,0.35);
	set_domain_texture(traversino3,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.47,0,0.48, TRUE, 0.35,0.35);
	set_scale(cuscino,1,1.105256078,1);
	set_projection_texture(cuscino,attributes[LEGNO_OPACO],"textures/paglia-sedia.hr", 2,TRUE, 0.5,0.5);
	set_scale(cuscino,1,0.9047677,1);
	set_domain_texture(poggiaschiena,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.32,0,0.27, TRUE, 0.35,0.35);
	set_domain_texture(tappo1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,1,0,1, TRUE, 0.35,0.35);
	set_domain_texture(tappo2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,1,0,1, TRUE, 0.35,0.35);
	
	
	//Creo la lista delle superfici
	ITEM sedia = create_list(gamba1,"Sedia1");
	sedia = insert_in_list(sedia,gamba2);
	sedia = insert_in_list(sedia,gamba3);
	sedia = insert_in_list(sedia,gamba4);
	sedia = insert_in_list(sedia,cuscino);
	sedia = insert_in_list(sedia,traversino1);
	sedia = insert_in_list(sedia,traversino2);
	sedia = insert_in_list(sedia,traversino3);
	sedia = insert_in_list(sedia,poggiaschiena);
	sedia = insert_in_list(sedia,tappo1);
	sedia = insert_in_list(sedia,tappo2);

	set_z_rotate(sedia,100,1);
	set_translate(sedia,-6.5,17.5,0);

	return sedia;
}



//  Sedia a sinistra del tavolo quadrato 1 piu' lontana rispetto all'osservatore
ITEM load_and_set_sedia2() {

	//Carico le superficie che compongono la sedia
	ITEM gamba1 = read_nurbs("sedia-gamba-davanti1.db");
	ITEM gamba2 = read_nurbs("sedia-gamba-davanti2.db");
	ITEM gamba3 = read_nurbs("sedia-gamba-dietro1.db");
	ITEM gamba4 = read_nurbs("sedia-gamba-dietro2.db");
	ITEM traversino1 = read_nurbs("sedia-traversino1.db");
	ITEM traversino2 = read_nurbs("sedia-traversino2.db");
	ITEM traversino3 = read_nurbs("sedia-traversino3.db");
	ITEM cuscino = read_nurbs("sedia-cuscino.db");
	ITEM poggiaschiena = read_nurbs("sedia-poggiaschiena.db");
	ITEM tappo1 = read_nurbs("sedia-tappo1.db");
	ITEM tappo2 = read_nurbs("sedia-tappo2.db");

	//Setto gli atributi delle superfici
	set_domain_texture(gamba1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.33,0,0.49, TRUE, 0.35,0.35);
	set_domain_texture(gamba2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.30,0,0.23, TRUE, 0.35,0.35);
	set_domain_texture(gamba3,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.23,0,0.31, TRUE, 0.35,0.35);
	set_domain_texture(gamba4,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.37,0,0.48, TRUE, 0.35,0.35);
	set_domain_texture(traversino1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.20,0,0.42, TRUE, 0.35,0.35);
	set_domain_texture(traversino2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.27,0,0.22, TRUE, 0.35,0.35);
	set_domain_texture(traversino3,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.47,0,0.48, TRUE, 0.35,0.35);
	set_scale(cuscino,1,1.105256078,1);
	set_projection_texture(cuscino,attributes[LEGNO_OPACO],"textures/paglia-sedia.hr", 2,TRUE, 0.5,0.5);
	set_scale(cuscino,1,0.9047677,1);
	set_domain_texture(poggiaschiena,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.32,0,0.27, TRUE, 0.35,0.35);
	set_domain_texture(tappo1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,1,0,1, TRUE, 0.35,0.35);
	set_domain_texture(tappo2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,1,0,1, TRUE, 0.35,0.35);
	
	
	//Creo la lista delle superfici
	ITEM sedia = create_list(gamba1,"Sedia2");
	sedia = insert_in_list(sedia,gamba2);
	sedia = insert_in_list(sedia,gamba3);
	sedia = insert_in_list(sedia,gamba4);
	sedia = insert_in_list(sedia,cuscino);
	sedia = insert_in_list(sedia,traversino1);
	sedia = insert_in_list(sedia,traversino2);
	sedia = insert_in_list(sedia,traversino3);
	sedia = insert_in_list(sedia,poggiaschiena);
	sedia = insert_in_list(sedia,tappo1);
	sedia = insert_in_list(sedia,tappo2);

	set_z_rotate(sedia,-95,1);
	set_translate(sedia,-10.85,17.65,0);

	return sedia;
}



//  Sedia a sinistra del tavolo quadrato 1 piu' vicina all'osservatore
ITEM load_and_set_sedia3() {

	//Carico le superficie che compongono la sedia
	ITEM gamba1 = read_nurbs("sedia-gamba-davanti1.db");
	ITEM gamba2 = read_nurbs("sedia-gamba-davanti2.db");
	ITEM gamba3 = read_nurbs("sedia-gamba-dietro1.db");
	ITEM gamba4 = read_nurbs("sedia-gamba-dietro2.db");
	ITEM traversino1 = read_nurbs("sedia-traversino1.db");
	ITEM traversino2 = read_nurbs("sedia-traversino2.db");
	ITEM traversino3 = read_nurbs("sedia-traversino3.db");
	ITEM cuscino = read_nurbs("sedia-cuscino.db");
	ITEM poggiaschiena = read_nurbs("sedia-poggiaschiena.db");
	ITEM tappo1 = read_nurbs("sedia-tappo1.db");
	ITEM tappo2 = read_nurbs("sedia-tappo2.db");

	//Setto gli atributi delle superfici
	set_domain_texture(gamba1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.33,0,0.49, TRUE, 0.35,0.35);
	set_domain_texture(gamba2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.30,0,0.23, TRUE, 0.35,0.35);
	set_domain_texture(gamba3,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.23,0,0.31, TRUE, 0.35,0.35);
	set_domain_texture(gamba4,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.37,0,0.48, TRUE, 0.35,0.35);
	set_domain_texture(traversino1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.20,0,0.42, TRUE, 0.35,0.35);
	set_domain_texture(traversino2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.27,0,0.22, TRUE, 0.35,0.35);
	set_domain_texture(traversino3,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.47,0,0.48, TRUE, 0.35,0.35);
	set_scale(cuscino,1,1.105256078,1);
	set_projection_texture(cuscino,attributes[LEGNO_OPACO],"textures/paglia-sedia.hr", 2,TRUE, 0.5,0.5);
	set_scale(cuscino,1,0.9047677,1);
	set_domain_texture(poggiaschiena,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.32,0,0.27, TRUE, 0.35,0.35);
	set_domain_texture(tappo1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,1,0,1, TRUE, 0.35,0.35);
	set_domain_texture(tappo2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,1,0,1, TRUE, 0.35,0.35);
	
	
	//Creo la lista delle superfici
	ITEM sedia = create_list(gamba1,"Sedia3");
	sedia = insert_in_list(sedia,gamba2);
	sedia = insert_in_list(sedia,gamba3);
	sedia = insert_in_list(sedia,gamba4);
	sedia = insert_in_list(sedia,cuscino);
	sedia = insert_in_list(sedia,traversino1);
	sedia = insert_in_list(sedia,traversino2);
	sedia = insert_in_list(sedia,traversino3);
	sedia = insert_in_list(sedia,poggiaschiena);
	sedia = insert_in_list(sedia,tappo1);
	sedia = insert_in_list(sedia,tappo2);

	set_z_rotate(sedia,-60,1);
	set_translate(sedia,-10.55,14.85,0);

	return sedia;
}



//  Sedia vicina al tavolo quadrato 2
ITEM load_and_set_sedia4() {

	//Carico le superficie che compongono la sedia
	ITEM gamba1 = read_nurbs("sedia-gamba-davanti1.db");
	ITEM gamba2 = read_nurbs("sedia-gamba-davanti2.db");
	ITEM gamba3 = read_nurbs("sedia-gamba-dietro1.db");
	ITEM gamba4 = read_nurbs("sedia-gamba-dietro2.db");
	ITEM traversino1 = read_nurbs("sedia-traversino1.db");
	ITEM traversino2 = read_nurbs("sedia-traversino2.db");
	ITEM traversino3 = read_nurbs("sedia-traversino3.db");
	ITEM cuscino = read_nurbs("sedia-cuscino.db");
	ITEM poggiaschiena = read_nurbs("sedia-poggiaschiena.db");
	ITEM tappo1 = read_nurbs("sedia-tappo1.db");
	ITEM tappo2 = read_nurbs("sedia-tappo2.db");

	//Setto gli atributi delle superfici
	set_domain_texture(gamba1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.33,0,0.49, TRUE, 0.35,0.35);
	set_domain_texture(gamba2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.30,0,0.23, TRUE, 0.35,0.35);
	set_domain_texture(gamba3,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.23,0,0.31, TRUE, 0.35,0.35);
	set_domain_texture(gamba4,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.37,0,0.48, TRUE, 0.35,0.35);
	set_domain_texture(traversino1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.20,0,0.42, TRUE, 0.35,0.35);
	set_domain_texture(traversino2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.27,0,0.22, TRUE, 0.35,0.35);
	set_domain_texture(traversino3,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.47,0,0.48, TRUE, 0.35,0.35);
	set_scale(cuscino,1,1.105256078,1);
	set_projection_texture(cuscino,attributes[LEGNO_OPACO],"textures/paglia-sedia.hr", 2,TRUE, 0.5,0.5);
	set_scale(cuscino,1,0.9047677,1);
	set_domain_texture(poggiaschiena,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.32,0,0.27, TRUE, 0.35,0.35);
	set_domain_texture(tappo1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,1,0,1, TRUE, 0.35,0.35);
	set_domain_texture(tappo2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,1,0,1, TRUE, 0.35,0.35);
	
	
	//Creo la lista delle superfici
	ITEM sedia = create_list(gamba1,"Sedia4");
	sedia = insert_in_list(sedia,gamba2);
	sedia = insert_in_list(sedia,gamba3);
	sedia = insert_in_list(sedia,gamba4);
	sedia = insert_in_list(sedia,cuscino);
	sedia = insert_in_list(sedia,traversino1);
	sedia = insert_in_list(sedia,traversino2);
	sedia = insert_in_list(sedia,traversino3);
	sedia = insert_in_list(sedia,poggiaschiena);
	sedia = insert_in_list(sedia,tappo1);
	sedia = insert_in_list(sedia,tappo2);

	set_z_rotate(sedia,192,1);
	set_translate(sedia,-10.65,11.5,0);

	return sedia;
}

//  Sedia tra il tavolo quadrato 3 e il tavolo quadrato 4
ITEM load_and_set_sedia5() {

	//Carico le superficie che compongono la sedia
	ITEM gamba1 = read_nurbs("sedia-gamba-davanti1.db");
	ITEM gamba2 = read_nurbs("sedia-gamba-davanti2.db");
	ITEM gamba3 = read_nurbs("sedia-gamba-dietro1.db");
	ITEM gamba4 = read_nurbs("sedia-gamba-dietro2.db");
	ITEM traversino1 = read_nurbs("sedia-traversino1.db");
	ITEM traversino2 = read_nurbs("sedia-traversino2.db");
	ITEM traversino3 = read_nurbs("sedia-traversino3.db");
	ITEM cuscino = read_nurbs("sedia-cuscino.db");
	ITEM poggiaschiena = read_nurbs("sedia-poggiaschiena.db");
	ITEM tappo1 = read_nurbs("sedia-tappo1.db");
	ITEM tappo2 = read_nurbs("sedia-tappo2.db");

	//Setto gli atributi delle superfici
	set_domain_texture(gamba1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.33,0,0.49, TRUE, 0.35,0.35);
	set_domain_texture(gamba2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.30,0,0.23, TRUE, 0.35,0.35);
	set_domain_texture(gamba3,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.23,0,0.31, TRUE, 0.35,0.35);
	set_domain_texture(gamba4,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.37,0,0.48, TRUE, 0.35,0.35);
	set_domain_texture(traversino1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.20,0,0.42, TRUE, 0.35,0.35);
	set_domain_texture(traversino2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.27,0,0.22, TRUE, 0.35,0.35);
	set_domain_texture(traversino3,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.47,0,0.48, TRUE, 0.35,0.35);
	set_scale(cuscino,1,1.105256078,1);
	set_projection_texture(cuscino,attributes[LEGNO_OPACO],"textures/paglia-sedia.hr", 2,TRUE, 0.5,0.5);
	set_scale(cuscino,1,0.9047677,1);
	set_domain_texture(poggiaschiena,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.32,0,0.27, TRUE, 0.35,0.35);
	set_domain_texture(tappo1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,1,0,1, TRUE, 0.35,0.35);
	set_domain_texture(tappo2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,1,0,1, TRUE, 0.35,0.35);
	
	
	//Creo la lista delle superfici
	ITEM sedia = create_list(gamba1,"Sedia5");
	sedia = insert_in_list(sedia,gamba2);
	sedia = insert_in_list(sedia,gamba3);
	sedia = insert_in_list(sedia,gamba4);
	sedia = insert_in_list(sedia,cuscino);
	sedia = insert_in_list(sedia,traversino1);
	sedia = insert_in_list(sedia,traversino2);
	sedia = insert_in_list(sedia,traversino3);
	sedia = insert_in_list(sedia,poggiaschiena);
	sedia = insert_in_list(sedia,tappo1);
	sedia = insert_in_list(sedia,tappo2);

	set_z_rotate(sedia,-75,1);
	set_translate(sedia,-7.7,-3.1,0);

	return sedia;
}



//  Sedia prima del tavolo quadrato 4 piu' lontana rispetto all'osservatore
ITEM load_and_set_sedia6() {

	//Carico le superficie che compongono la sedia
	ITEM gamba1 = read_nurbs("sedia-gamba-davanti1.db");
	ITEM gamba2 = read_nurbs("sedia-gamba-davanti2.db");
	ITEM gamba3 = read_nurbs("sedia-gamba-dietro1.db");
	ITEM gamba4 = read_nurbs("sedia-gamba-dietro2.db");
	ITEM traversino1 = read_nurbs("sedia-traversino1.db");
	ITEM traversino2 = read_nurbs("sedia-traversino2.db");
	ITEM traversino3 = read_nurbs("sedia-traversino3.db");
	ITEM cuscino = read_nurbs("sedia-cuscino.db");
	ITEM poggiaschiena = read_nurbs("sedia-poggiaschiena.db");
	ITEM tappo1 = read_nurbs("sedia-tappo1.db");
	ITEM tappo2 = read_nurbs("sedia-tappo2.db");

	//Setto gli atributi delle superfici
	set_domain_texture(gamba1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.33,0,0.49, TRUE, 0.35,0.35);
	set_domain_texture(gamba2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.30,0,0.23, TRUE, 0.35,0.35);
	set_domain_texture(gamba3,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.23,0,0.31, TRUE, 0.35,0.35);
	set_domain_texture(gamba4,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.37,0,0.48, TRUE, 0.35,0.35);
	set_domain_texture(traversino1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.20,0,0.42, TRUE, 0.35,0.35);
	set_domain_texture(traversino2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.27,0,0.22, TRUE, 0.35,0.35);
	set_domain_texture(traversino3,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.47,0,0.48, TRUE, 0.35,0.35);
	set_scale(cuscino,1,1.105256078,1);
	set_projection_texture(cuscino,attributes[LEGNO_OPACO],"textures/paglia-sedia.hr", 2,TRUE, 0.5,0.5);
	set_scale(cuscino,1,0.9047677,1);
	set_domain_texture(poggiaschiena,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.32,0,0.27, TRUE, 0.35,0.35);
	set_domain_texture(tappo1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,1,0,1, TRUE, 0.35,0.35);
	set_domain_texture(tappo2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,1,0,1, TRUE, 0.35,0.35);
	
	
	//Creo la lista delle superfici
	ITEM sedia = create_list(gamba1,"Sedia6");
	sedia = insert_in_list(sedia,gamba2);
	sedia = insert_in_list(sedia,gamba3);
	sedia = insert_in_list(sedia,gamba4);
	sedia = insert_in_list(sedia,cuscino);
	sedia = insert_in_list(sedia,traversino1);
	sedia = insert_in_list(sedia,traversino2);
	sedia = insert_in_list(sedia,traversino3);
	sedia = insert_in_list(sedia,poggiaschiena);
	sedia = insert_in_list(sedia,tappo1);
	sedia = insert_in_list(sedia,tappo2);

	set_z_rotate(sedia,-80,1);
	set_translate(sedia,-8,-9.5,0);

	return sedia;
}



//  Sedia prima del tavolo quadrato 4 piu' vicina rispetto all'osservatore
ITEM load_and_set_sedia7() {

	//Carico le superficie che compongono la sedia
	ITEM gamba1 = read_nurbs("sedia-gamba-davanti1.db");
	ITEM gamba2 = read_nurbs("sedia-gamba-davanti2.db");
	ITEM gamba3 = read_nurbs("sedia-gamba-dietro1.db");
	ITEM gamba4 = read_nurbs("sedia-gamba-dietro2.db");
	ITEM traversino1 = read_nurbs("sedia-traversino1.db");
	ITEM traversino2 = read_nurbs("sedia-traversino2.db");
	ITEM traversino3 = read_nurbs("sedia-traversino3.db");
	ITEM cuscino = read_nurbs("sedia-cuscino.db");
	ITEM poggiaschiena = read_nurbs("sedia-poggiaschiena.db");
	ITEM tappo1 = read_nurbs("sedia-tappo1.db");
	ITEM tappo2 = read_nurbs("sedia-tappo2.db");

	//Setto gli atributi delle superfici
	set_domain_texture(gamba1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.33,0,0.49, TRUE, 0.35,0.35);
	set_domain_texture(gamba2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.30,0,0.23, TRUE, 0.35,0.35);
	set_domain_texture(gamba3,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.23,0,0.31, TRUE, 0.35,0.35);
	set_domain_texture(gamba4,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.37,0,0.48, TRUE, 0.35,0.35);
	set_domain_texture(traversino1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.20,0,0.42, TRUE, 0.35,0.35);
	set_domain_texture(traversino2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.27,0,0.22, TRUE, 0.35,0.35);
	set_domain_texture(traversino3,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.47,0,0.48, TRUE, 0.35,0.35);
	set_scale(cuscino,1,1.105256078,1);
	set_projection_texture(cuscino,attributes[LEGNO_OPACO],"textures/paglia-sedia.hr", 2,TRUE, 0.5,0.5);
	set_scale(cuscino,1,0.9047677,1);
	set_domain_texture(poggiaschiena,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.32,0,0.27, TRUE, 0.35,0.35);
	set_domain_texture(tappo1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,1,0,1, TRUE, 0.35,0.35);
	set_domain_texture(tappo2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,1,0,1, TRUE, 0.35,0.35);
	
	
	//Creo la lista delle superfici
	ITEM sedia = create_list(gamba1,"Sedia7");
	sedia = insert_in_list(sedia,gamba2);
	sedia = insert_in_list(sedia,gamba3);
	sedia = insert_in_list(sedia,gamba4);
	sedia = insert_in_list(sedia,cuscino);
	sedia = insert_in_list(sedia,traversino1);
	sedia = insert_in_list(sedia,traversino2);
	sedia = insert_in_list(sedia,traversino3);
	sedia = insert_in_list(sedia,poggiaschiena);
	sedia = insert_in_list(sedia,tappo1);
	sedia = insert_in_list(sedia,tappo2);

	set_z_rotate(sedia,110,1);
	set_translate(sedia,-6,-11.25,0);

	return sedia;
}



//  Sedia a destra del tavolo lungo 1
ITEM load_and_set_sedia8() {

	//Carico le superficie che compongono la sedia
	ITEM gamba1 = read_nurbs("sedia-gamba-davanti1.db");
	ITEM gamba2 = read_nurbs("sedia-gamba-davanti2.db");
	ITEM gamba3 = read_nurbs("sedia-gamba-dietro1.db");
	ITEM gamba4 = read_nurbs("sedia-gamba-dietro2.db");
	ITEM traversino1 = read_nurbs("sedia-traversino1.db");
	ITEM traversino2 = read_nurbs("sedia-traversino2.db");
	ITEM traversino3 = read_nurbs("sedia-traversino3.db");
	ITEM cuscino = read_nurbs("sedia-cuscino.db");
	ITEM poggiaschiena = read_nurbs("sedia-poggiaschiena.db");
	ITEM tappo1 = read_nurbs("sedia-tappo1.db");
	ITEM tappo2 = read_nurbs("sedia-tappo2.db");

	//Setto gli atributi delle superfici
	set_domain_texture(gamba1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.33,0,0.49, TRUE, 0.35,0.35);
	set_domain_texture(gamba2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.30,0,0.23, TRUE, 0.35,0.35);
	set_domain_texture(gamba3,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.23,0,0.31, TRUE, 0.35,0.35);
	set_domain_texture(gamba4,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.37,0,0.48, TRUE, 0.35,0.35);
	set_domain_texture(traversino1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.20,0,0.42, TRUE, 0.35,0.35);
	set_domain_texture(traversino2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.27,0,0.22, TRUE, 0.35,0.35);
	set_domain_texture(traversino3,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.47,0,0.48, TRUE, 0.35,0.35);
	set_scale(cuscino,1,1.105256078,1);
	set_projection_texture(cuscino,attributes[LEGNO_OPACO],"textures/paglia-sedia.hr", 2,TRUE, 0.5,0.5);
	set_scale(cuscino,1,0.9047677,1);
	set_domain_texture(poggiaschiena,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.32,0,0.27, TRUE, 0.35,0.35);
	set_domain_texture(tappo1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,1,0,1, TRUE, 0.35,0.35);
	set_domain_texture(tappo2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,1,0,1, TRUE, 0.35,0.35);
	
	
	//Creo la lista delle superfici
	ITEM sedia = create_list(gamba1,"Sedia8");
	sedia = insert_in_list(sedia,gamba2);
	sedia = insert_in_list(sedia,gamba3);
	sedia = insert_in_list(sedia,gamba4);
	sedia = insert_in_list(sedia,cuscino);
	sedia = insert_in_list(sedia,traversino1);
	sedia = insert_in_list(sedia,traversino2);
	sedia = insert_in_list(sedia,traversino3);
	sedia = insert_in_list(sedia,poggiaschiena);
	sedia = insert_in_list(sedia,tappo1);
	sedia = insert_in_list(sedia,tappo2);

	set_z_rotate(sedia,115,1);
	set_translate(sedia,9.25,0.75,0);

	return sedia;
}



//  Sedia a sinistra del tavolo lungo 1
ITEM load_and_set_sedia9() {

	//Carico le superficie che compongono la sedia
	ITEM gamba1 = read_nurbs("sedia-gamba-davanti1.db");
	ITEM gamba2 = read_nurbs("sedia-gamba-davanti2.db");
	ITEM gamba3 = read_nurbs("sedia-gamba-dietro1.db");
	ITEM gamba4 = read_nurbs("sedia-gamba-dietro2.db");
	ITEM traversino1 = read_nurbs("sedia-traversino1.db");
	ITEM traversino2 = read_nurbs("sedia-traversino2.db");
	ITEM traversino3 = read_nurbs("sedia-traversino3.db");
	ITEM cuscino = read_nurbs("sedia-cuscino.db");
	ITEM poggiaschiena = read_nurbs("sedia-poggiaschiena.db");
	ITEM tappo1 = read_nurbs("sedia-tappo1.db");
	ITEM tappo2 = read_nurbs("sedia-tappo2.db");

	//Setto gli atributi delle superfici
	set_domain_texture(gamba1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.33,0,0.49, TRUE, 0.35,0.35);
	set_domain_texture(gamba2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.30,0,0.23, TRUE, 0.35,0.35);
	set_domain_texture(gamba3,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.23,0,0.31, TRUE, 0.35,0.35);
	set_domain_texture(gamba4,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.37,0,0.48, TRUE, 0.35,0.35);
	set_domain_texture(traversino1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.20,0,0.42, TRUE, 0.35,0.35);
	set_domain_texture(traversino2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.27,0,0.22, TRUE, 0.35,0.35);
	set_domain_texture(traversino3,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.47,0,0.48, TRUE, 0.35,0.35);
	set_scale(cuscino,1,1.105256078,1);
	set_projection_texture(cuscino,attributes[LEGNO_OPACO],"textures/paglia-sedia.hr", 2,TRUE, 0.5,0.5);
	set_scale(cuscino,1,0.9047677,1);
	set_domain_texture(poggiaschiena,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.32,0,0.27, TRUE, 0.35,0.35);
	set_domain_texture(tappo1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,1,0,1, TRUE, 0.35,0.35);
	set_domain_texture(tappo2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,1,0,1, TRUE, 0.35,0.35);
	
	
	//Creo la lista delle superfici
	ITEM sedia = create_list(gamba1,"Sedia9");
	sedia = insert_in_list(sedia,gamba2);
	sedia = insert_in_list(sedia,gamba3);
	sedia = insert_in_list(sedia,gamba4);
	sedia = insert_in_list(sedia,cuscino);
	sedia = insert_in_list(sedia,traversino1);
	sedia = insert_in_list(sedia,traversino2);
	sedia = insert_in_list(sedia,traversino3);
	sedia = insert_in_list(sedia,poggiaschiena);
	sedia = insert_in_list(sedia,tappo1);
	sedia = insert_in_list(sedia,tappo2);

	set_z_rotate(sedia,-35,1);
	set_translate(sedia,5.25,-0.75,0);

	return sedia;
}



//  Sedia a sinistra del tavolo lungo 2 piu' lontana rispetto all'osservatore
ITEM load_and_set_sedia10() {

	//Carico le superficie che compongono la sedia
	ITEM gamba1 = read_nurbs("sedia-gamba-davanti1.db");
	ITEM gamba2 = read_nurbs("sedia-gamba-davanti2.db");
	ITEM gamba3 = read_nurbs("sedia-gamba-dietro1.db");
	ITEM gamba4 = read_nurbs("sedia-gamba-dietro2.db");
	ITEM traversino1 = read_nurbs("sedia-traversino1.db");
	ITEM traversino2 = read_nurbs("sedia-traversino2.db");
	ITEM traversino3 = read_nurbs("sedia-traversino3.db");
	ITEM cuscino = read_nurbs("sedia-cuscino.db");
	ITEM poggiaschiena = read_nurbs("sedia-poggiaschiena.db");
	ITEM tappo1 = read_nurbs("sedia-tappo1.db");
	ITEM tappo2 = read_nurbs("sedia-tappo2.db");

	//Setto gli atributi delle superfici
	set_domain_texture(gamba1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.33,0,0.49, TRUE, 0.35,0.35);
	set_domain_texture(gamba2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.30,0,0.23, TRUE, 0.35,0.35);
	set_domain_texture(gamba3,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.23,0,0.31, TRUE, 0.35,0.35);
	set_domain_texture(gamba4,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.37,0,0.48, TRUE, 0.35,0.35);
	set_domain_texture(traversino1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.20,0,0.42, TRUE, 0.35,0.35);
	set_domain_texture(traversino2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.27,0,0.22, TRUE, 0.35,0.35);
	set_domain_texture(traversino3,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.47,0,0.48, TRUE, 0.35,0.35);
	set_scale(cuscino,1,1.105256078,1);
	set_projection_texture(cuscino,attributes[LEGNO_OPACO],"textures/paglia-sedia.hr", 2,TRUE, 0.5,0.5);
	set_scale(cuscino,1,0.9047677,1);
	set_domain_texture(poggiaschiena,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.32,0,0.27, TRUE, 0.35,0.35);
	set_domain_texture(tappo1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,1,0,1, TRUE, 0.35,0.35);
	set_domain_texture(tappo2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,1,0,1, TRUE, 0.35,0.35);
	
	
	//Creo la lista delle superfici
	ITEM sedia = create_list(gamba1,"Sedia10");
	sedia = insert_in_list(sedia,gamba2);
	sedia = insert_in_list(sedia,gamba3);
	sedia = insert_in_list(sedia,gamba4);
	sedia = insert_in_list(sedia,cuscino);
	sedia = insert_in_list(sedia,traversino1);
	sedia = insert_in_list(sedia,traversino2);
	sedia = insert_in_list(sedia,traversino3);
	sedia = insert_in_list(sedia,poggiaschiena);
	sedia = insert_in_list(sedia,tappo1);
	sedia = insert_in_list(sedia,tappo2);

	set_z_rotate(sedia,-60,1);
	set_translate(sedia,5.3,-6.25,0);

	return sedia;
}



//  Sedia a destra del tavolo lungo 2
ITEM load_and_set_sedia11() {

	//Carico le superficie che compongono la sedia
	ITEM gamba1 = read_nurbs("sedia-gamba-davanti1.db");
	ITEM gamba2 = read_nurbs("sedia-gamba-davanti2.db");
	ITEM gamba3 = read_nurbs("sedia-gamba-dietro1.db");
	ITEM gamba4 = read_nurbs("sedia-gamba-dietro2.db");
	ITEM traversino1 = read_nurbs("sedia-traversino1.db");
	ITEM traversino2 = read_nurbs("sedia-traversino2.db");
	ITEM traversino3 = read_nurbs("sedia-traversino3.db");
	ITEM cuscino = read_nurbs("sedia-cuscino.db");
	ITEM poggiaschiena = read_nurbs("sedia-poggiaschiena.db");
	ITEM tappo1 = read_nurbs("sedia-tappo1.db");
	ITEM tappo2 = read_nurbs("sedia-tappo2.db");

	//Setto gli atributi delle superfici
	set_domain_texture(gamba1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.33,0,0.49, TRUE, 0.35,0.35);
	set_domain_texture(gamba2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.30,0,0.23, TRUE, 0.35,0.35);
	set_domain_texture(gamba3,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.23,0,0.31, TRUE, 0.35,0.35);
	set_domain_texture(gamba4,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.37,0,0.48, TRUE, 0.35,0.35);
	set_domain_texture(traversino1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.20,0,0.42, TRUE, 0.35,0.35);
	set_domain_texture(traversino2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.27,0,0.22, TRUE, 0.35,0.35);
	set_domain_texture(traversino3,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.47,0,0.48, TRUE, 0.35,0.35);
	set_scale(cuscino,1,1.105256078,1);
	set_projection_texture(cuscino,attributes[LEGNO_OPACO],"textures/paglia-sedia.hr", 2,TRUE, 0.5,0.5);
	set_scale(cuscino,1,0.9047677,1);
	set_domain_texture(poggiaschiena,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.32,0,0.27, TRUE, 0.35,0.35);
	set_domain_texture(tappo1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,1,0,1, TRUE, 0.35,0.35);
	set_domain_texture(tappo2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,1,0,1, TRUE, 0.35,0.35);
	
	
	//Creo la lista delle superfici
	ITEM sedia = create_list(gamba1,"Sedia11");
	sedia = insert_in_list(sedia,gamba2);
	sedia = insert_in_list(sedia,gamba3);
	sedia = insert_in_list(sedia,gamba4);
	sedia = insert_in_list(sedia,cuscino);
	sedia = insert_in_list(sedia,traversino1);
	sedia = insert_in_list(sedia,traversino2);
	sedia = insert_in_list(sedia,traversino3);
	sedia = insert_in_list(sedia,poggiaschiena);
	sedia = insert_in_list(sedia,tappo1);
	sedia = insert_in_list(sedia,tappo2);

	set_z_rotate(sedia,113,1);
	set_translate(sedia,8.8,-5,0);

	return sedia;
}



//  Sedia a sinistra del tavolo lungo 2 piu' vicina rispetto all'osservatore
ITEM load_and_set_sedia12() {

	//Carico le superficie che compongono la sedia
	ITEM gamba1 = read_nurbs("sedia-gamba-davanti1.db");
	ITEM gamba2 = read_nurbs("sedia-gamba-davanti2.db");
	ITEM gamba3 = read_nurbs("sedia-gamba-dietro1.db");
	ITEM gamba4 = read_nurbs("sedia-gamba-dietro2.db");
	ITEM traversino1 = read_nurbs("sedia-traversino1.db");
	ITEM traversino2 = read_nurbs("sedia-traversino2.db");
	ITEM traversino3 = read_nurbs("sedia-traversino3.db");
	ITEM cuscino = read_nurbs("sedia-cuscino.db");
	ITEM poggiaschiena = read_nurbs("sedia-poggiaschiena.db");
	ITEM tappo1 = read_nurbs("sedia-tappo1.db");
	ITEM tappo2 = read_nurbs("sedia-tappo2.db");

	//Setto gli atributi delle superfici
	set_domain_texture(gamba1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.33,0,0.49, TRUE, 0.35,0.35);
	set_domain_texture(gamba2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.30,0,0.23, TRUE, 0.35,0.35);
	set_domain_texture(gamba3,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.23,0,0.31, TRUE, 0.35,0.35);
	set_domain_texture(gamba4,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.37,0,0.48, TRUE, 0.35,0.35);
	set_domain_texture(traversino1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.20,0,0.42, TRUE, 0.35,0.35);
	set_domain_texture(traversino2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.27,0,0.22, TRUE, 0.35,0.35);
	set_domain_texture(traversino3,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.47,0,0.48, TRUE, 0.35,0.35);
	set_scale(cuscino,1,1.105256078,1);
	set_projection_texture(cuscino,attributes[LEGNO_OPACO],"textures/paglia-sedia.hr", 2,TRUE, 0.5,0.5);
	set_scale(cuscino,1,0.9047677,1);
	set_domain_texture(poggiaschiena,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,0.32,0,0.27, TRUE, 0.35,0.35);
	set_domain_texture(tappo1,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,1,0,1, TRUE, 0.35,0.35);
	set_domain_texture(tappo2,attributes[LEGNO_LUCIDO],"textures/legno-sedia.hr", 0,1,0,1, TRUE, 0.35,0.35);
	
	
	//Creo la lista delle superfici
	ITEM sedia = create_list(gamba1,"Sedia12");
	sedia = insert_in_list(sedia,gamba2);
	sedia = insert_in_list(sedia,gamba3);
	sedia = insert_in_list(sedia,gamba4);
	sedia = insert_in_list(sedia,cuscino);
	sedia = insert_in_list(sedia,traversino1);
	sedia = insert_in_list(sedia,traversino2);
	sedia = insert_in_list(sedia,traversino3);
	sedia = insert_in_list(sedia,poggiaschiena);
	sedia = insert_in_list(sedia,tappo1);
	sedia = insert_in_list(sedia,tappo2);

	set_z_rotate(sedia,-73,1);
	set_translate(sedia,5.1,-9.8,0);

	return sedia;
}



//  Teca sul bancone & teche contenute all'interno della teca stessa
ITEM load_and_set_teca(int deep) {

	//   Crea una lista con tutti gli oggetti che sono contenuti all'interno della teca (tutta la scena ad esclusione degli specchi, dell'orologio, della tenda e della cornell box)
	ITEM load_and_set_teca_object() {
		ITEM obj = create_list(load_and_set_biliardo(),"Oggetti-Dentro-Teca");
		obj = insert_in_list(obj,load_and_set_tavolo_quadrato1());
		obj = insert_in_list(obj,load_and_set_tavolo_quadrato2());
		obj = insert_in_list(obj,load_and_set_tavolo_quadrato3());
		obj = insert_in_list(obj,load_and_set_tavolo_quadrato4());
		obj = insert_in_list(obj,load_and_set_piedistallo());
		obj = insert_in_list(obj,load_and_set_tavolo_rosso());
		obj = insert_in_list(obj,load_and_set_bancone());
		obj = insert_in_list(obj,load_and_set_tavolo_lungo1());
		obj = insert_in_list(obj,load_and_set_tavolo_lungo2());
		obj = insert_in_list(obj,load_and_set_lampada_nera());
		obj = insert_in_list(obj,load_and_set_lampada_gialla1());
		obj = insert_in_list(obj,load_and_set_lampada_gialla2());
		obj = insert_in_list(obj,load_and_set_lampada_gialla3());
		obj = insert_in_list(obj,load_and_set_sedia1());
		obj = insert_in_list(obj,load_and_set_sedia2());
		obj = insert_in_list(obj,load_and_set_sedia3());
		obj = insert_in_list(obj,load_and_set_sedia4());
		obj = insert_in_list(obj,load_and_set_sedia5());
		obj = insert_in_list(obj,load_and_set_sedia6());
		obj = insert_in_list(obj,load_and_set_sedia7());
		obj = insert_in_list(obj,load_and_set_sedia8());
		obj = insert_in_list(obj,load_and_set_sedia9());
		obj = insert_in_list(obj,load_and_set_sedia10());
		obj = insert_in_list(obj,load_and_set_sedia11());
		obj = insert_in_list(obj,load_and_set_sedia12());

		return obj;
	}
	
	//Carico la teca di vetro
	ITEM vetro = read_nurbs("teca.db");
	
	ITEM teca;
	char string[5];
	
	//Setto l'attributo materiale della teca
	set_attribute(vetro,attributes[VETRO_TRASPARENTE]);
	
	sprintf(string,"Teca%d",deep);

	//Se ho raggiunto l'ultimo livello di annidamento delle teche mi fermo altrimenti richiamo la funzione per inserire una teca dentro un'altra teca
	if(deep == 1) 
		teca = create_list(load_and_set_teca_object(),string);
	if(deep > 1 && deep < 10) {
		teca = create_list(load_and_set_teca(deep-1),string);
		teca = insert_in_list(teca,load_and_set_teca_object());
	}

	//Scalo e posiziono la teca e gli oggetti in essa contenuti
	set_scale(teca,0.12695,0.12695,0.12695);
	teca = insert_in_list(teca,vetro);
	set_z_rotate(teca,-90,1);
	set_translate(teca,-2.35+DIM_BANCONE_X/2,DIM_STANZA_Y/2-DIM_BANCONE_Y/2-3.2,DIM_BANCONE_Z);
	
	return teca;
}



//  Creo le luci della mia scena, una in corrispondenza di ogni lampada e 2 inesistenti alle spalle dell'osservatore per rendere piu' luminoso l'ambiente senza snaturarlo con un'eccessiva luce ambiente
void set_lights() {

	create_point_light(-1.5,-6,DIM_STANZA_Z-4.15040-0.65, 1,1,1, 1, 30, "Luce-Lampada-Nera");
	create_point_light(-8.6,11.5,DIM_STANZA_Z-4.91153-0.65, 1,1,1, 1, 30, "Luce-Lampada-Gialla1");
	create_point_light(3.6,5,DIM_STANZA_Z-4.91153-0.65, 1,1,1, 1, 30, "Luce-Lampada-Gialla2");
	create_point_light(4.8,-6,DIM_STANZA_Z-4.91153-0.65, 1,1,1, 1, 30, "Luce-Lampada-Gialla3");
	create_point_light(-3.77571,25.99482,DIM_STANZA_Z-2.5, 1,1,1, 1, 30, "Luce-Cornell-Box");
	create_warn_light(-12,-18,8, 0.518,0.793,-0.317, 1,1,1, 1, 30, 1, 30, 0,0,0,0,0, "Luce-Fittizia1");
	create_warn_light(0,-18,8, -0.096,0.911,-0.4, 1,1,1, 1, 30, 1, 30, 0,0,0,0,0, "Luce-Fittizia2");
	set_ambient_light(1,1,1, 0.5);

}



//  Scena
ITEM carica_oggetti() {
	ITEM main_scene = create_list(load_and_set_stanza(),"caffe-interno");
	main_scene = insert_in_list(main_scene,load_and_set_cornell_box());
	main_scene = insert_in_list(main_scene,load_and_set_biliardo());
	main_scene = insert_in_list(main_scene,load_and_set_tavolo_quadrato1());
	main_scene = insert_in_list(main_scene,load_and_set_tavolo_quadrato2());
	main_scene = insert_in_list(main_scene,load_and_set_tavolo_quadrato3());
	main_scene = insert_in_list(main_scene,load_and_set_tavolo_quadrato4());
	main_scene = insert_in_list(main_scene,load_and_set_piedistallo());
	main_scene = insert_in_list(main_scene,load_and_set_specchio_piccolo());
	main_scene = insert_in_list(main_scene,load_and_set_specchio_nascosto());
	main_scene = insert_in_list(main_scene,load_and_set_orologio());
	main_scene = insert_in_list(main_scene,load_and_set_tavolo_rosso());
	main_scene = insert_in_list(main_scene,load_and_set_bancone());
	main_scene = insert_in_list(main_scene,load_and_set_tavolo_lungo1());
	main_scene = insert_in_list(main_scene,load_and_set_tavolo_lungo2());
	main_scene = insert_in_list(main_scene,load_and_set_specchio_arcuato());
	main_scene = insert_in_list(main_scene,load_and_set_lampada_nera());
	main_scene = insert_in_list(main_scene,load_and_set_lampada_gialla1());
	main_scene = insert_in_list(main_scene,load_and_set_lampada_gialla2());
	main_scene = insert_in_list(main_scene,load_and_set_lampada_gialla3());
	main_scene = insert_in_list(main_scene,load_and_set_sedia1());
	main_scene = insert_in_list(main_scene,load_and_set_sedia2());
	main_scene = insert_in_list(main_scene,load_and_set_sedia3());
	main_scene = insert_in_list(main_scene,load_and_set_sedia4());
	main_scene = insert_in_list(main_scene,load_and_set_sedia5());
	main_scene = insert_in_list(main_scene,load_and_set_sedia6());
	main_scene = insert_in_list(main_scene,load_and_set_sedia7());
	main_scene = insert_in_list(main_scene,load_and_set_sedia8());
	main_scene = insert_in_list(main_scene,load_and_set_sedia9());
	main_scene = insert_in_list(main_scene,load_and_set_sedia10());
	main_scene = insert_in_list(main_scene,load_and_set_sedia11());
	main_scene = insert_in_list(main_scene,load_and_set_sedia12());
	main_scene = insert_in_list(main_scene,load_and_set_teca(TECA_DEEP));
	return main_scene;
}



//  Setto gli attributi degli oggetti, carico gli oggetti, setto le luci, setto lo sfondo e salvo la scena
int main(int argc, char* argv[]) {
	set_attributes(attributes);
	ITEM caffe_interno = carica_oggetti();
	set_lights();
	set_background(0.855,0.8,0.388, FALSE);
	save_scene("caffe-interno.md","caffe-interno",caffe_interno);
	return(0);
}

